"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class PromiseUtil {
    static sleep(timeout) {
        if (timeout < 0)
            timeout = 0;
        return new Promise(resolve => {
            setTimeout(() => resolve(), timeout);
        });
    }
    static waitFor(condition, timeout = 30000) {
        return new Promise(resolve => {
            const start = new Date().getTime();
            const wait = () => {
                if (new Date().getTime() - start >= timeout)
                    resolve(false);
                else if (condition())
                    resolve(true);
                else
                    setTimeout(wait, 100);
            };
            wait();
        });
    }
}
exports.PromiseUtil = PromiseUtil;
//# sourceMappingURL=PromiseUtil.js.map